#include <PS2X_lib.h>            //声明PS2手柄库
#include <Servo.h>   
PS2X ps2x;                    //声明舵机库
#define  BEEP_PIN   12           //定义蜂鸣器引脚D6
#define  NLED_PIN   13           //定义呼吸灯引脚D11
#define  NLED_MS_BETWEEN        1000
#define SER1_BAUD   9600
#define  DUOJI_MS_BETWEEN       20.000
#define DJ_NUM  6                //宏定义伺服舵机的个数  
/*电机驱动引脚*/
#define PWMB_IN1 11       //定义IN1引脚
#define PWMB_IN2  6       //定义IN2引脚
#define PWMA_IN1  5        //定义IN3引脚
#define PWMA_IN2  3        //定义IN4引脚
/******************************************************************
 宏定义PS2手柄引脚，用有有意义的字符代表相应是引脚，便于使用
******************************************************************/
#define PS2_DAT      8     
#define PS2_CMD      9
#define PS2_ATT      2  
#define PS2_CLK      4  
#define  PS2_MS_BETWEEN         50
byte type = 0;
String uart1_receive_buf = "";   //声明一个字符串数组
int get_byte = 0;       // 接收到的 data byte
boolean newLineReceived = false; // 前一次数据结束标志
boolean startBit  = false;  //协议开始标志
Servo myservo[DJ_NUM];           //创建舵机伺服对象数组
unsigned int duoji_index;       //声明舵机变量 （舵机号）
byte duoji_pin[DJ_NUM] = {10, A2, A3, A0, A1, 7};//定义一个数组，存储引脚数字
unsigned int Pwm_Value[6]={1500,1500,1500,1500,1500,1500};
void dida(u8 times,u8 frequency);
void handle_nled();
void handle_ps2();
void Parse_str(String str);
void Motor_Forward(char motor,char pwm);
void Motor_Back(char motor,char pwm);
void Motor_Right(char motor,char pwm);
void Motor_Left(char motor,char pwm);
void Motor_Stop(char motor);
unsigned char handle_ms_between( unsigned long *time_ms, unsigned int ms_between);
void setup() {
      for(byte i = 0; i < DJ_NUM; i++)
          {//循环使相应的舵机伺服对象连接到对应的引脚
            myservo[i].attach(duoji_pin[i]); 
          }
      for(byte i = 0; i < DJ_NUM; i++) 
        {
            myservo[i].writeMicroseconds(Pwm_Value[i]);//循环写入初始PWM目标值 
        }
     Serial.begin(SER1_BAUD);                           
     Serial.println("uart1 init OK");
     pinMode(BEEP_PIN, OUTPUT);
     pinMode(NLED_PIN, OUTPUT);
    ps2x.config_gamepad(PS2_CLK, PS2_CMD, PS2_ATT, PS2_DAT, true, true);//配置PS2手柄
    type = ps2x.readType();//返回PS2类型
     switch(type) {
       case 0:
        Serial.println("Unknown Controller type");
       break;
       case 1:
        Serial.println("DualShock Controller Found");
       break;
       case 2:
         Serial.println("GuitarHero Controller Found");
       break;
     }
     dida(3,100);
     Motor_Stop(1);
     Motor_Stop(2);
}

void loop() 
{
    handle_nled();
    handle_ps2();
    Parse_str(uart1_receive_buf);
}

//serialEvent()是IDE1.0及以后版本新增的功能，不清楚为什么大部份人不愿意用，这个可是相当于中断功能一样的啊!  
void serialEvent()
{
  while (Serial.available()) 
  {    
    get_byte = Serial.read();              //一个字节一个字节地读，下一句是读到的放入字符串数组中组成一个完成的数据包
    if(get_byte== '<'||get_byte=='d'||get_byte=='a')
    {
      startBit= true;
    }
    if(startBit == true)
    {
       uart1_receive_buf += (char) get_byte;     // 全双工串口可以不用在下面加延时，半双工则要加的//
    }  
    if (get_byte == '>'||get_byte=='!') 
    {
       newLineReceived = true; 
       startBit = false;
    }
  }
}

void Parse_str(String str)
{
  int index=0,len=0,i=0;
  int pwm=0;
  if (newLineReceived)
  {
           if(str[0] =='a')
              {
                if(str[5] =='1')  index=1;
                if(str[5] =='2')  index=2;
                if(str[5] =='3')  index=3;
                if(str[5] =='4')  index=4;
                if(str[5] =='5')  index=5;
                if(str[5] =='6')  index=6;
                len = str.length();  //获取串口接收数据的长度
                pwm=0;  
                  for(i = 0; i < len; i++) {              //如果数据没有接收完
                      if(str[i] == ':') {         //判断是否为起始符“#”
                          i++;                                  //下一个字符
                          while((str[i] != '!') && (i<len)) {  //判断是否为#后面的数字检测完
                              pwm =  pwm*10 + str[i] - '0';  //记录P之前的数字
                              i++;
                          }  
                                          //检测完后赋值
                       Pwm_Value[index-1]=pwm;
                       myservo[index-1].writeMicroseconds(Pwm_Value[index-1]);
                       index = pwm = 0; 
                  }
               }
           }
         else if((str[0] =='<') && (str[1] =='S'))
          {   
            if((str[2] =='U') && (str[3] =='P')) index=1;
            if((str[2] =='D') && (str[3] =='N')) index=2;
            if((str[2] =='L') && (str[3] =='T')) index=3;
            if((str[2] =='R') && (str[3] =='T')) index=4;
            if((str[2] =='D') && (str[3] =='L')) index=5;
            if((str[2] =='D') && (str[3] =='R')) index=6;
            len = str.length();  //获取串口接收数据的长度
            pwm=0;        
            for(i = 0; i < len; i++) {              //如果数据没有接收完
                if(str[i] == '-') {         //判断是否为起始符“#”
                    i++;                                  //下一个字符
                    while((str[i] != '>') && (i<len)) {  //判断是否为#后面的数字检测完
                        pwm =  pwm*10 + str[i] - '0';  //记录P之前的数字
                        i++;
                    }                     
                    //检测完后赋值
                   Pwm_Value[index-1]=pwm;
                   myservo[index-1].writeMicroseconds(Pwm_Value[index-1]);
                   index = pwm = 0; 
                }
             }
           } 
          else if(str[0] == '<' && (str[1] == 'B') && (str[2] == 'U') 
                    && (str[3] == 'P') && (str[4] == 'D') && (str[5]== '>')) 
                {
                     Motor_Back(1,100);
                     Motor_Back(2,100);
                   Serial.println("Foward");
                }    
          else if(str[0] == '<' && (str[1] == 'B') && (str[2] == 'D') 
              && (str[3] == 'N') && (str[4] == 'D') && (str[5] == '>')) 
          {

             Motor_Forward(1,100);
             Motor_Forward(2,100);
             Serial.println("Back");
          } 

         else if(str[0] == '<' && (str[1] == 'B') && (str[2] == 'L') 
              && (str[3] == 'T') && (str[4] == 'D') && (str[5] == '>')) 
          {
             Motor_Forward(1,100);
             Motor_Back(2,100); 
             Serial.println("Left");
          } 
         else if(str[0] == '<' && (str[1] == 'B') && (str[2] == 'R') 
              && (str[3] == 'T') && (str[4] == 'D') && (str[5] == '>')) 
          {
             Motor_Forward(2,100);
             Motor_Back(1,100); 
             Serial.println("Right");
          } 
         else if(str[0] == '<' && (str[1] == 'B') && (str[4] == 'U') && (str[5] == '>')) 
          {
                Motor_Stop(1); 
                Motor_Stop(2); 
          } 
        else if(str[0] =='d')
          {     
              if(str[10] =='r' && str[11] =='u')      {   Motor_Forward(1,100);     Motor_Forward(2,100);   }
              if(str[10] =='b')                       {   Motor_Back(1,100);        Motor_Back(2,100);      }
              if(str[10] =='l')                       {   Motor_Forward(1,100);     Motor_Back(2,100);  }
              if(str[10] =='r'&& str[11] =='i' )      {   Motor_Forward(2,100);     Motor_Back(1,100);  }
              if(str[10] =='s')                       {   Motor_Stop(1);  Motor_Stop(2);}
          }
         
      newLineReceived=false;
      uart1_receive_buf=""; 
  } 
}



unsigned char handle_ms_between( unsigned long *time_ms, unsigned int ms_between) {
    if(millis() - *time_ms < ms_between) {
        return 0;  
    } else{
         *time_ms = millis();
         return 1;
    }
}

void dida(u8 times, u8 frequency) {
    for(byte i = 0; i < times; i++ ) {
        digitalWrite(BEEP_PIN, LOW);
        delay(frequency);
        digitalWrite(BEEP_PIN, HIGH );
        delay(frequency);  
    }
}

unsigned char val = 0;
void handle_nled() {
    static unsigned long systick_ms_bak = 0;
    if(!handle_ms_between(&systick_ms_bak, NLED_MS_BETWEEN))return;  
    digitalWrite(NLED_PIN, val);
    val = ~val;
}


void Motor_Forward(char motor,char pwm)
{
  if(motor==1)
  {
     analogWrite(PWMA_IN1,pwm);
     analogWrite(PWMA_IN2,255);
  }
  else if(motor==2)
  {
     analogWrite(PWMB_IN1,pwm);
     analogWrite(PWMB_IN2,255); 
  }
}

void Motor_Back(char motor,char pwm)
{
  if(motor==1)
  {
     analogWrite(PWMA_IN1,255);
     analogWrite(PWMA_IN2,pwm);
  }
  else if(motor==2)
  {
     analogWrite(PWMB_IN1,255);
     analogWrite(PWMB_IN2,pwm); 
  }
}

void Motor_Right(char motor,char pwm)
{
    if(motor==1)
  {
     analogWrite(PWMA_IN1,pwm);
     analogWrite(PWMA_IN2,255);
  }
  else if(motor==2)
  {
     analogWrite(PWMB_IN1,255);
     analogWrite(PWMB_IN2,pwm); 
  }
}

void Motor_Left(char motor,char pwm)
{
    if(motor==1)
  {
     analogWrite(PWMA_IN1,255);
     analogWrite(PWMA_IN2,pwm);
  }
  else if(motor==2)
  {
     analogWrite(PWMB_IN1,pwm);
     analogWrite(PWMB_IN2,255); 
  }
}
void Motor_Stop(char motor)
{
    if(motor==1)
  {
      //digitalWrite(PWMA_IN1,LOW );
      //digitalWrite(PWMA_IN2,LOW );
     analogWrite(PWMA_IN1,255);
     analogWrite(PWMA_IN2,255);
  }
  else if(motor==2)
  {
      //digitalWrite(PWMB_IN1,LOW );
      //digitalWrite(PWMB_IN2,LOW );
     analogWrite(PWMB_IN1,255);
     analogWrite(PWMB_IN2,255); 
  }
}


void handle_ps2() {        //手柄出来函数
    static unsigned long systick_ms_bak = 0;
    static unsigned char car_active = 0, car_stoped=0;
    if(!handle_ms_between(&systick_ms_bak, PS2_MS_BETWEEN))return;  
    ps2x.read_gamepad();   //读PS2数据
    if(ps2x.Button(PSB_L1))  { 
        Pwm_Value[4]+=15;
        if(Pwm_Value[4]>=2500)  Pwm_Value[4]=2500; 
        myservo[4].writeMicroseconds(Pwm_Value[4]);
    } else if(ps2x.Button(PSB_L2)) {
        Pwm_Value[4]-=15;
        if(Pwm_Value[4]<=500)  Pwm_Value[4]=500;
         myservo[4].writeMicroseconds(Pwm_Value[4]);
    } else if(ps2x.Button(PSB_R1)) { 
        Pwm_Value[5]+=15;
        if(Pwm_Value[5]>=2500)  Pwm_Value[5]=2500;   
         myservo[5].writeMicroseconds(Pwm_Value[5]);        
    } else if(ps2x.Button(PSB_R2)) {
        Pwm_Value[5]-=15;
        if(Pwm_Value[5]<=500)  Pwm_Value[5]=500;
        myservo[5].writeMicroseconds(Pwm_Value[5]);        
    } else if(ps2x.Button(PSB_PAD_UP)) {
        Pwm_Value[1]+=15;
        if(Pwm_Value[1]>=2500)  Pwm_Value[1]=2500;
         myservo[1].writeMicroseconds(Pwm_Value[1]);
    } else if(ps2x.Button(PSB_PAD_DOWN)) {
        Pwm_Value[1]-=15;
        if(Pwm_Value[1]<=500)  Pwm_Value[1]=500; 
        myservo[1].writeMicroseconds(Pwm_Value[1]);      
    } else if(ps2x.Button(PSB_PAD_LEFT)) { 
        Pwm_Value[0]+=15;
        if(Pwm_Value[0]>=2500)  Pwm_Value[0]=2500;
          myservo[0].writeMicroseconds(Pwm_Value[0]);
        //Serial.println(pwm_value[0], DEC);
                               
    } else if(ps2x.Button(PSB_PAD_RIGHT)) {
       Pwm_Value[0]-=15;
        if(Pwm_Value[0]<=500)  Pwm_Value[0]=500;
         myservo[0].writeMicroseconds(Pwm_Value[0]);
           //Serial.println(pwm_value[0], DEC);  
    } else if(ps2x.Button(PSB_PINK)) {
        Pwm_Value[2]+=15;
        if(Pwm_Value[2]>=2500)  Pwm_Value[2]=2500;
        myservo[2].writeMicroseconds(Pwm_Value[2]);      
    } else if(ps2x.Button(PSB_GREEN)) {
        Pwm_Value[3]+=15;
        if(Pwm_Value[3]>=2500)  Pwm_Value[3]=2500; 
      myservo[3].writeMicroseconds(Pwm_Value[3]);   
    } else if(ps2x.Button(PSB_RED)) {
        Pwm_Value[2]-=15;
        if(Pwm_Value[2]<=500)  Pwm_Value[2]=500;  
        myservo[2].writeMicroseconds(Pwm_Value[2]); 
    } else if(ps2x.Button(PSB_BLUE))  {
         Pwm_Value[3]-=15;
        if(Pwm_Value[3]<=500)  Pwm_Value[3]=500; 
       myservo[3].writeMicroseconds(Pwm_Value[3]);  
    } else if(ps2x.Button(PSB_SELECT)) {            
          Serial.println("PSB_SELECT pressed");
    }     
    
     if(ps2x.ButtonReleased(PSB_SELECT))  ;
       //按键弹起时，发送“$DST！”指令，舵机停在此时的位置
    if(ps2x.ButtonReleased(PSB_L1)||ps2x.ButtonReleased(PSB_R1)||
       ps2x.ButtonReleased(PSB_L2)||ps2x.ButtonReleased(PSB_R2)||
       ps2x.ButtonReleased(PSB_PAD_UP)||ps2x.ButtonReleased(PSB_PAD_DOWN)||
       ps2x.ButtonReleased(PSB_PAD_LEFT)||ps2x.ButtonReleased(PSB_PAD_RIGHT)||
       ps2x.ButtonReleased(PSB_PINK)||ps2x.ButtonReleased(PSB_RED)||
       ps2x.ButtonReleased(PSB_BLUE)||ps2x.ButtonReleased(PSB_GREEN)) {
       uart1_receive_buf = "$DST!";
    }      

    if((ps2x.Analog(PSS_RY)>=100 && ps2x.Analog(PSS_RY)<=150) && (ps2x.Analog(PSS_LY)>=100 && ps2x.Analog(PSS_LY)<=150)) {
        if(!car_stoped) {
          Motor_Stop(1);
          Motor_Stop(2);
          car_stoped = 1;
        }
    }

    
   if((ps2x.Analog(PSS_LY)>=188) && (ps2x.Analog(PSS_LY)<=255))
   {
       if(car_active>=0x0f)
       {
           Motor_Forward(1,100);
           car_stoped = 0;
       }
       car_active |= (1<<0);  
   }

   else if((ps2x.Analog(PSS_LY)>=0) && (ps2x.Analog(PSS_LY)<68)) 
   {
       if(car_active>=0x0f)
       {
           Motor_Back(1,100);
           car_stoped = 0;
       }
       car_active |= (1<<1);
   }
   
   if((ps2x.Analog(PSS_RY)>=188) && (ps2x.Analog(PSS_RY)<=255))
      { 
       if(car_active>=0x0f)
       {
           Motor_Forward(2,100);
           car_stoped = 0;
       }
       car_active |= (1<<2);
      }
   else if((ps2x.Analog(PSS_RY)>=0) && (ps2x.Analog(PSS_RY)<68)) 
     {
       if(car_active>=0x0f)
       {
           Motor_Back(2,100);
           car_stoped = 0;
       }
       car_active |= (1<<3);
     }
}

     





